#Cislo 197 nazyvame aj rotacnym prvocislom, pretoze akokolvek budeme posuvat/menit poradie 
#jeho cislic: 197, 971, 719, vzdy budu aj tieto cisla prvocislami. 

#Existuje trinast rotacnych prvocisel mensich ako 100:
#2, 3, 5, 7, 11, 13, 17, 31, 37, 71, 73, 79, a 97.

#Zistite a vypiste kolko je rotacnych prvocisel mensich ako milion.

def zisti(w)
  @w = w/2
  for i in 2..@w
    if w % i == 0
      #puts "#{cisla[x]} nieje prvocislo"
      return false
      break
    end
    if i == @w
      #puts "#{w} je prvocislo"
      return true
    end
  end
end

def makaj(min,max)
  cislo = Array.new
  #for x in min..max #naplnim pole "cislo"
    #if not x.to_s =~ /0|2|4|5|6|8/
      #if zisti(x) #som to rozdelil na dve podmienky, imho je to rychlejsie o nieco
        #cislo.push x
      #end
    #end
  #end
  #cislo.delete nil
  #cislo.uniq!
  #p cislo
  #gets
  cislo = [2, 3, 5, 7, 11, 13, 17, 19, 31, 37, 71, 73, 79, 97, 113, 131, 137, 139, 173, 179, 191, 193, 197, 199, 311, 313, 317, 331, 337, 373, 379, 397, 719, 733, 739, 773, 797, 911, 919, 937, 971, 977, 991, 997, 1117, 1171, 1193, 1319, 1373, 1399, 1733, 1777, 1913, 1931, 1933, 1973, 1979, 1993, 1997, 1999, 3119, 3137, 3191, 3313, 3319, 3331, 3371, 3373, 3391, 3719, 3733, 3739, 3779, 3793, 3797, 3911, 3917, 3919, 3931, 7177, 7193, 7331, 7333, 7393, 7717, 7793, 7919, 7933, 7937, 7993, 9133, 9137, 9173, 9199, 9311, 9319, 9337, 9371, 9377, 9391, 9397, 9719, 9733, 9739, 9791, 9931, 9973, 11113, 11117, 11119, 11131, 11171, 11173, 11177, 11197, 11311, 11317, 11393, 11399, 11717, 11719, 11731, 11777, 11779, 11933, 11939, 11971, 13171, 13177, 13313, 13331, 13337, 13339, 13397, 13399, 13711, 13799, 13913, 13931, 13933, 13997, 13999, 17117, 17137, 17191, 17317, 17333, 17377, 17393, 17713, 17737, 17791, 17911, 17939, 17971, 17977, 19139, 19319, 19333, 19373, 19379, 19391, 19717, 19739, 19777, 19793, 19913, 19919, 19937, 19973, 19979, 19991, 19993, 19997, 31139, 31177, 31193, 31319, 31333, 31337, 31379, 31391, 31393, 31397, 31771, 31793, 31799, 31973, 31991, 33113, 33119, 33179, 33191, 33199, 33311, 33317, 33331, 33377, 33391, 33713, 33739, 33773, 33791, 33797, 33911, 33931, 33937, 33997, 37117, 37139, 37171, 37199, 37313, 37337, 37339, 37379, 37397, 37717, 37799, 37991, 37993, 37997, 39113, 39119, 39133, 39139, 39191, 39199, 39313, 39317, 39371, 39373, 39397, 39719, 39733, 39779, 39791, 39799, 39937, 39971, 39979, 71119, 71171, 71191, 71317, 71333, 71339, 71399, 71711, 71713, 71719, 71777, 71917, 71933, 71971, 71993, 71999, 73133, 73331, 73379, 73771, 73939, 73973, 73999, 77137, 77171, 77191, 77317, 77339, 77377, 77711, 77713, 77719, 77731, 77773, 77797, 77933, 77977, 77999, 79111, 79133, 79139, 79193, 79319, 79333, 79337, 79379, 79393, 79397, 79399, 79777, 79939, 79973, 79979, 79997, 79999, 91139, 91193, 91199, 91331, 91373, 91393, 91397, 91711, 91733, 91771, 91939, 91997, 93113, 93131, 93133, 93139, 93179, 93199, 93319, 93337, 93371, 93377, 93719, 93739, 93911, 93913, 93937, 93971, 93979, 93997, 97117, 97171, 97177, 97373, 97379, 97397, 97711, 97771, 97777, 97919, 97931, 97973, 99119, 99131, 99133, 99137, 99139, 99173, 99191, 99317, 99371, 99377, 99391, 99397, 99713, 99719, 99733, 99793, 99971, 99991]
  x = y = @@pocetRotacnychCisel = 0
  cisla = []
  cisla[0] = cislo[0].to_s
  while x < cislo[y].to_s.length  #do polia "cisla" ulozime vsetky moznosti obmien z "cislo"
    pocetW = 0
    cisla[x] = cisla[x-1].to_s[1..-1] + cisla[x-1][0].chr
    if x == cislo[y].to_s.length-1
      #teraz mam v "cisla" ulozene vsetko co potrebujem, a idem testovat a skrtat
      cisla.each do |w|
        cislo.delete(w.to_i)
        if zisti(w.to_i)
          pocetW += 1
          if pocetW == cisla.length
            puts cisla[-1]
            @@pocetRotacnychCisel += 1
          end
        end
      end
      x = 0
      cisla = []
      cisla[0] = cislo[y].to_s
      y = y + 1
    else
      x += 1
    end
  end
end

makaj(2,100000)
puts "Cisel je " + @@pocetRotacnychCisel.to_s

